<template>
  <div class="bg-gray-100">
    <transition name="fade">
      <div v-show="openedNav.status" :class="openedNav.status ? 'z-10' : 'hidden'" @click.prevent="clickHandler" class="bg-wrapper fixed bg-gray-900 transition-all duration-1000 ease-out bg-opacity-50  h-screen w-screen bottom-0 left-0"></div>
    </transition>
    <div class="border-b-2 border-gray-500 border-opacity-25 bg-white relative w-full">
      <Header />
    </div>
    <div class="bg-gray-100">
      <div class="px-4 lg:container lg:mx-auto w-full h-full main-wrapper">
        <nuxt />
      </div>
      <div class="relative bottom-0 w-auto h-48 mb-0">
        <Footer />
      </div>
    </div>
  </div>
</template>

<script>
import Header from '~/components/app/Header.vue'
import Footer from '~/components/app/Footer.vue'

export default {
	components: {
    Header,
    Footer
  },

  watch: {
    openedNav(value) {
      const wrapper = document.querySelector('.bg-wrapper')
      if (value.status == true) {
        if (wrapper.classList.contains('hidden')) wrapper.classList.remove('hidden')
      } else {
        wrapper.classList.add('hidden')
      }
    }
  },

  mounted() {
    this.openedNav = {
      status: false
    }

    this.onResize()
    window.addEventListener('resize', this.onResize, { passive: true })
  },

  beforeDestroy() {
    if (typeof window === 'undefined') return

    window.removeEventListener('resize', this.onResize, { passive: true })
  },

  methods: {
    clickHandler(e) {
      this.$store.dispatch('setOpenedNav', Object.assign({ ...this.openedNav }, { status: false }))
    },

    onResize() {
      this.$store.dispatch('setIsMobile', window.innerWidth < 768)
      this.$store.dispatch('setIsTablet', window.innerWidth >= 768 && window.innerWidth < 1024)
    }
  },

  computed: {
    openedNav: {
      get() {
        return this.$store.state.openedNav
      },
      set(value) {
        this.$store.commit('SET_OPENED_NAV', value)
      }
    }
  }

}
</script>

<style scoped>
  .fade-enter-active, .fade-leave-active {
    transition: all .75s ease-in-out;
  }
  .fade-enter, .fade-leave-to /* .fade-leave-active below version 2.1.8 */ {
    /* transform: translate(0px, 100px) rotate(0deg) !important; */
    opacity: 0;
  }
</style>
